;--------------------------------------------------------------------------------------------------------------------------------
;La conversion de l'entre analogique AN0 est dclenche automatiquement par le TIMER3 
;Lorsque la conversion est termine le convertisseur dclenche une demande d'interruption
;la routine d'interruption  envoie les 8bits de poids forts du rsultat de la conversion  sur le port D
;Le programme principal aprs l'appel des sous programmes d'initialisation excute une boucle infinie
;---------------------------------------------------------------------------------------------------------------------------------
		.global			__reset	               ;  adresse 000000 de la mmoire programme  ( voir fichier 30F6014.gld  ) 
		.global			__ADCInterrupt  ;adresse du vecteur d'interruption ADC 
		.section        .text	;  indique au  linker d'utiliser la mmoire programme
;**********************************************
;   Le Programme principal
;**********************************************
__reset:rcall   _init_timer3    ;  appel des sous-programmes                  
		rcall   _init_portD
		rcall   _init_adc
		rcall	_init_int
boucle: nop						; boucle infinie....
		bra boucle
;fin du_programme principal..........


;*********************************************
; Routine de traitement de l'interruption ADC
;*********************************************
__ADCInterrupt:
		mov ADCBUF0,W0			;lecture AN0 
		lsr W0,#8,W0			;dcalage  droite de huit bits 
		mov W0,PORTD			;envoi en sortie	
		bclr IFS0,#11			;rinitialise l'indicateur d'interruption ADC	
		RETFIE
;*******************************************
;    Les sous-programmes
;*******************************************   
_init_portD:
		clr TRISD
		return
_init_timer3:
		mov #0x8000,W0
		mov W0,T3CON
		mov #100,W0
		mov W0,PR3
		return
_init_adc:
		clr ADPCFG
		mov #0x0400,W0
		mov W0,ADCON2
		mov #0x010A,W0
		mov W0,ADCON3
		mov #0x0000,W0
		mov W0,ADCHS
		mov #0x0001,W0
		mov W0,ADCSSL
		mov #0x8246,W0
		mov W0,ADCON1
		return
_init_int:
		bclr IFS0,#11
		bset IEC0,#11
		return
.end   						; fin du fichier




